#include <Arduino.h>
#include <WiFi.h>
#include <WiFiClient.h>
#include <WiFiAP.h>
#include <WebServer.h>
#include <PubSubClient.h>
#include <ArduinoJson.h>
#include "DHTesp.h"


DHTesp DhtSensor1;

const char* ssid = "WIFI SSID";	//AT KELL IRNI
const char* password =  "WIFI PW";	//AT KELL IRNI
const char* mqttServer = "mqtt.paas.oringnet.cloud";
const int mqttPort = 1883;
const char* mqttUser = "oring thing Identity";	//AT KELL IRNI
const char* mqttPassword = "oring thing Secret";	//AT KELL IRNI

int j=0;
char paychar[40];

StaticJsonBuffer<300> JSONbuffer;
JsonObject& JSONencoder = JSONbuffer.createObject();
char JSONmessageBuffer[100];

WiFiClient espClient;
PubSubClient client(espClient);

void callback(char* topic, byte* payload, unsigned int length) {
  
 
  for (int i = 0; i < length; i++) {
       
    paychar[i]=(char)payload[i];
    
  }
 
  Serial.println();
 
}

void setup() {
  // put your setup code here, to run once:
 DhtSensor1.setup(16, DHTesp::DHT11);
  
  Serial.begin(115200);
  Serial.println();
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.println("Csatlakozas WiFi halozathoz");
  }
 
  Serial.println("WiFi csatlakozas sikeres!");
 
  client.setServer(mqttServer, mqttPort);
  client.setCallback(callback);
 
  while (!client.connected()) {
    Serial.println("MQTT csatlakozas...");
	//AT KELL IRNI
    if (client.connect("oring thing Client ID", mqttUser, mqttPassword )) {
 
      Serial.println("MQTT csatlakozva!");
 
    } else {
 
      Serial.print("MQTT csatlakozas sikertelen!");
      Serial.println(client.state());
      delay(1000);
 
    }
  } 
}

void loop() {
  // put your main code here, to run repeatedly:
  int humid = 2;

  int temp = 3;


if(j == 100)
  {
		//AT KELL IRNI
  JSONencoder["id"] = "hum";	//oring - Thing - Data - Shape ID
  JSONencoder["value"] = humid;

  JSONencoder.printTo(JSONmessageBuffer, sizeof(JSONmessageBuffer));
  Serial.println("Uzenet kuldese - MQTT topic..");
  Serial.println(JSONmessageBuffer);
 //AT KELL IRNI - oring Thing - Data 
  if (client.publish("$thing/Hfp2LQ89L/$data/DHT11", JSONmessageBuffer) == true) {
    Serial.println("Sikeres kuldes!");
  } else {
    Serial.println("Kuldes sikertelen!");
    
  }

		//AT KELL IRNI
  JSONencoder["id"] = "temp";	//oring - Thing - Data - Shape ID
  JSONencoder["value"] = temp;


  JSONencoder.printTo(JSONmessageBuffer, sizeof(JSONmessageBuffer));
  Serial.println("Uzenet kuldese - MQTT topic..");
  Serial.println(JSONmessageBuffer);

 
  if (client.publish("$thing/Hfp2LQ89L/$data/DHT11", JSONmessageBuffer) == true) {
    Serial.println("Sikeres kuldes!");
  } else {
    Serial.println("Kuldes sikertelen!");
  }


j=0;
  }

  else { 
 
  client.loop();

j++;
delay(100);

 }
}